from config import read_config
from get_from_tagia import TaigaReader
from page_writer import PageWriter

taiga, wiki = read_config('config.ini')
reader = TaigaReader(taiga)
writer = PageWriter(wiki)

persons_by_roles = dict()
for person in reader.get_persons():
    if not (person.role_name in persons_by_roles):
        persons_by_roles[person.role_name] = []
    persons_by_roles[person.role_name].append(person)

    is_succes, message = writer.write_person_page(person)
    if not is_succes:
        print(f'Page not created for: {person.username}, message: {message}')

writer.write_list_page(persons_by_roles)

print('Pages created')